using System;
using System.IO;
using System.Collections;
using Server;
using Server.Misc;
using Server.Items;
using Server.Custom;

namespace Server.Mobiles
{

	public enum SpeechType
	{
		Common, Elven, Orc, Drow, Undead, Jibberish, Druidic, Umbravox, Abyssal
	}



	public class PolyGlotMobile : Mobile
	{

		private SpeechType LangSpeak;

		private bool m_KnowDrow;
		private bool m_KnowElven;
		private bool m_KnowOrc;
		private bool m_KnowUndead;
		private bool m_KnowDruidic;
		private bool m_KnowUmbravox;
		private bool m_KnowAbyssal;

		private bool m_TTied; // For Tongue Tied spell              

		#region Custom Public Properties

		[CommandProperty (AccessLevel.GameMaster)]
		public bool KnowDrow
		{
			get{ return m_KnowDrow; }
			set{ m_KnowDrow = value; }
		}

		[CommandProperty (AccessLevel.GameMaster)]
		public bool KnowElven
		{
			get{ return m_KnowElven; }
			set{ m_KnowElven= value; }
		}

		[CommandProperty (AccessLevel.GameMaster)]
		public bool KnowOrc
		{
			get{ return m_KnowOrc; }
			set{ m_KnowOrc = value; }
		}

		[CommandProperty (AccessLevel.GameMaster)]
		public bool KnowUndead
		{
			get{ return m_KnowUndead; }
			set{ m_KnowUndead = value; }
		}

		[CommandProperty (AccessLevel.GameMaster)]
		public bool KnowDruidic
		{
			get{ return m_KnowDruidic; }
			set{ m_KnowDruidic = value; }
		}

		[CommandProperty (AccessLevel.GameMaster)]
		public bool KnowUmbravox
		{
			get{ return m_KnowUmbravox; }
			set{ m_KnowUmbravox = value; }
		}

		[CommandProperty (AccessLevel.GameMaster)]
		public bool KnowAbyssal
		{
			get{ return m_KnowAbyssal; }
			set{ m_KnowAbyssal = value; }
		}

		[CommandProperty (AccessLevel.GameMaster)]
		public bool TTied
		{
			get{ return m_TTied; }
			set{ m_TTied = value; }
		}

		[CommandProperty (AccessLevel.GameMaster)]
		public SpeechType LanguageSpeaking
		{
			get{ return LangSpeak; }
			set{ LangSpeak = value; }
		}

        #endregion

        public PolyGlotMobile()
		{
            LangSpeak = SpeechType.Common;
			m_KnowDrow = false;
			m_KnowElven = false;
			m_KnowOrc = false;
			m_KnowUndead = false;
			m_KnowDruidic = false;
			m_KnowUmbravox = false;
			m_KnowAbyssal = false;
			m_TTied = false;
		}

        public PolyGlotMobile( Serial s ) : base( s )
		{
			
		}


		public override void Serialize (GenericWriter writer)
		{
			base.Serialize (writer);
			writer.Write ((int)1);//version	

			// case 1
			writer.Write ((bool)m_KnowDrow);
			writer.Write ((bool)m_KnowElven);
			writer.Write ((bool)m_KnowOrc);
			writer.Write ((bool)m_KnowUndead);
			writer.Write ((bool)m_KnowDruidic);
			writer.Write ((bool)m_KnowUmbravox);
			writer.Write ((bool)m_KnowAbyssal);

		}

		public override void Deserialize (GenericReader reader)
		{
			base.Deserialize (reader);
			int version = reader.ReadInt();

			switch (version)
			{
				case 1:
					{
						LangSpeak = SpeechType.Common;
						m_KnowDrow = reader.ReadBool();
						m_KnowElven = reader.ReadBool();
						m_KnowOrc = reader.ReadBool();
						m_KnowUndead = reader.ReadBool();
						m_KnowDruidic = reader.ReadBool();
						m_KnowUmbravox = reader.ReadBool();
						m_KnowAbyssal = reader.ReadBool();
						goto case 0;
					}

				case 0:
					break;
			}
		}
	}
}


